import java.io.*;
import java.util.*;

public class strings_bm {
	FastScanner in;
	PrintWriter out;

	// 20:31
	// 20:34

	void solve() {
		int tc = in.nextInt();
		final int mod = (int) 1e9 + 7;
		final int MAX = 111;
		int[][] c = new int[MAX][MAX];
		for (int i = 0; i < MAX; i++) {
			c[i][0] = 1;
			if (i != 0) {
				for (int j = 1; j < MAX; j++) {
					c[i][j] = c[i - 1][j - 1] + c[i - 1][j];
					if (c[i][j] >= mod) {
						c[i][j] -= mod;
					}
				}
			}
		}
		for (int t = 0; t < tc; t++) {
			int n = in.nextInt();
			int k = in.nextInt();
			String s = in.next();
			int cntOnes = 0, cntZeros = 0;
			for (char ch : s.toCharArray()) {
				if (ch == '0') {
					cntZeros++;
				} else {
					cntOnes++;
				}
			}
			long result = 0;
			for (int remOnes = 0; remOnes <= cntOnes / 3; remOnes++) {
				for (int remZeros = 0; remZeros <= cntZeros / 2; remZeros++) {
					int len = s.length() - remOnes * 3 - remZeros * 2;
					if (len == k) {
						result += c[len][cntOnes - 3 * remOnes];
					}
				}
			}
			out.println(result % mod);
		}
	}

	void run() {
		try {
			in = new FastScanner(new File("object.in"));
			out = new PrintWriter(new File("object.out"));

			solve();

			out.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	void runIO() {

		in = new FastScanner(System.in);
		out = new PrintWriter(System.out);

		solve();

		out.close();
	}

	class FastScanner {
		BufferedReader br;
		StringTokenizer st;

		public FastScanner(File f) {
			try {
				br = new BufferedReader(new FileReader(f));
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		}

		public FastScanner(InputStream f) {
			br = new BufferedReader(new InputStreamReader(f));
		}

		String next() {
			while (st == null || !st.hasMoreTokens()) {
				String s = null;
				try {
					s = br.readLine();
				} catch (IOException e) {
					e.printStackTrace();
				}
				if (s == null)
					return null;
				st = new StringTokenizer(s);
			}
			return st.nextToken();
		}

		boolean hasMoreTokens() {
			while (st == null || !st.hasMoreTokens()) {
				String s = null;
				try {
					s = br.readLine();
				} catch (IOException e) {
					e.printStackTrace();
				}
				if (s == null)
					return false;
				st = new StringTokenizer(s);
			}
			return true;
		}

		int nextInt() {
			return Integer.parseInt(next());
		}

		long nextLong() {
			return Long.parseLong(next());
		}

		double nextDouble() {
			return Double.parseDouble(next());
		}
	}

	public static void main(String[] args) {
		new strings_bm().runIO();
	}
}