#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
using namespace std;

const int MOD = (int)1e9 + 7;

int main()
{
    vector<vector<int> > c(102, vector<int>(102, 0));
    for (int i = 0; i < 102; i++)
        c[i][i] = 1, c[i][0] = 1;
    for (int i = 1; i < 102; i++)
        for (int j = 1; j < 102; j++)
            c[i][j] = (c[i - 1][j - 1] + c[i - 1][j]) % MOD;
    /*for (int i = 1; i < 10; i++)
    {    
        for (int j = 1; j < 10; j++)
        {
            cout << c[i][j] << ' ';      
        }
        cout << endl;
    }*/ 
    int t;
    cin >> t;
    while (t--) 
    {
        int n, k;
        string s;
        cin >> n >> k >> s;
        int ones = 0, zeros = 0;
        for (int i = 0; i < n; i++)
        {    
            if (s[i] == '0')
                zeros++;
            else
                ones++;
        }
        int res = 0;
        for (int x = 0; 2 * x <= zeros; x++)
            for (int y = 0; 3 * y <= ones; y++)
                if (2 * x + 3 * y == n - k)
                {
                    //cerr << x << ' ' << y << endl;
                    res = (res + c[k][ones - 3 * y]) % MOD;
                }
        //cerr << endl;
        cout << res << endl;
    }
    return 0;
}