#include <bits/stdc++.h>

using namespace std;

int main() {
    int T;
    cin >> T;
    while (T--) {
        int n, m;
        cin >> n >> m;
        vector<int> a(n);
        for (int i = 0; i < n; i++) cin >> a[i], a[i]--;

        vector<vector<pair<int, int> > > e(n);
        for (int i = 0; i < m; i++) {
            int u, v, c;
            cin >> u >> v >> c;
            --u; --v;
            e[u].push_back(make_pair(v, c));
            e[v].push_back(make_pair(u, c));
        }

        if (n % 2 == 1) {
            cout << "NO" << endl;
            continue;
        }

        vector<int> used(n);
        vector<vector<pair<int, int> > > vct;
        while (1) {
            int v = -1;
            for (int i = 0; i < n; i++) if (!used[i] && a[i] != -1) v = i;
            for (int i = 0; i < n; i++) if (!used[i] && v == -1) v = i;
            if (v == -1) break;
            
            queue<pair<int, int> > q;
            q.push(make_pair(v, 0));
            used[v] = 1;
            vector<pair<int, int> > cvct;
            while (!q.empty()) {
                int v = q.front().first, d = q.front().second;
                cvct.push_back(make_pair(v, d));
                q.pop();
                for (int i = 0; i < (int)e[v].size(); i++) {
                    int to = e[v][i].first;
                    if (!used[to]) {
                        used[to] = 1;
                        q.push(make_pair(to, d ^ e[v][i].second));
                    }
                }
            }
            vct.push_back(cvct);
        }

        int k = vct.size();
        vector<vector<int> > p(k + 1, vector<int>(n + 1, -1));
        p[0][0] = -2;
        for (int i = 0; i < k; i++) {
            int cnt = 0;
            for (int j = 0; j < (int)vct[i].size(); j++) cnt += vct[i][j].second == 0;

            for (int j = 0; j <= n; j++) {
                if (p[i][j] == -1) continue;
                if (a[vct[i][0].first] == -1 || a[vct[i][0].first] == 0) {
                    p[i + 1][j + cnt] = 0;
                }
                if (a[vct[i][0].first] == -1 || a[vct[i][0].first] == 1) {
                    p[i + 1][j + (int)vct[i].size() - cnt] = 1;
                }
            }
        }

        if (p[k][n / 2] == -1) {
            cout << "NO" << endl;
            continue;
        }

        vector<int> ans(n);
        int ci = k, cj = n / 2;
        while (ci) {
            int ncj = cj;
            for (int i = 0; i < (int)vct[ci - 1].size(); i++) {
                ans[vct[ci - 1][i].first] = vct[ci - 1][i].second ^ p[ci][cj];
                ncj -= ans[vct[ci - 1][i].first] == 0;
            }
            ci--;
            cj = ncj;
        }
        cout << "YES" << endl;
        for (int i = 0; i < n; i++) cout << ans[i] + 1 << " \n"[i + 1 == n];
    }
}