#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
const int MAXN = 1 << 20;

struct event {
    int x;
    ll a, b;

    event() {}
    event(int x, ll a, ll b) : x(x), a(a), b(b) {}
    
    bool operator< (const event &e) const {
        return x < e.x;
    }
};

int n;
pair<int, int> a[MAXN];

int main() {
    scanf("%d", &n);
    for (int i = 0; i < n; i++) scanf("%d%d", &a[i].second, &a[i].first); // I want to wrap horisontally

    int mn = 0;
    for (int i = 0; i < n; i++) if (a[i] < a[mn]) mn = i;
    rotate(a, a + mn, a + n);
    
    int mx = 0;
    for (int i = 0; i < n; i++) if (a[i] > a[mx]) mx = i;

    vector<pair<int, int> > up, down;
    for (int i = 0; i <= mx; i++) down.push_back(a[i]);
    up.push_back(a[0]);
    for (int i = n - 1; i >= mx; i--) up.push_back(a[i]);

//    for (int i = 0; i < (int)up.size(); i++) cerr << up[i].first << " " << up[i].second << endl;
//    cerr << endl;
//    for (int i = 0; i < (int)down.size(); i++) cerr << down[i].first << " " << down[i].second << endl;

    ll ans = 0;
    vector<int> pts;
    vector<event> events;

    int u = 0, d = 0;                  
    int cur = a[0].first;
    while (cur < a[mx].first) {
        int tg;
        int start = down[d].second;
        int end = up[u].second;
        bool o = 0;
        if (up[u].first <= down[d].first) {
            if (cur != up[u].first) {
                ans += 1LL * (up[u].first - cur) * (up[u].second - down[d].second);
                tg = up[u].first - cur;
                o = 1;
                // add in down[d].second linear function with tangent up[u].first - cur
                // add in (up[u].second + down[d].second)          -2(up[u].first - cur)
                // add in up[u].second                                up[u].first - cur
            }
            cur = up[u++].first;
        } else {
            if (cur != down[d].first) {
                ans += 1LL * (down[d].first - cur) * (up[u].second - down[d].second);
                tg = down[d].first - cur;
                o = 1;
            }
            cur = down[d++].first;            
        }

        if (o) {
            pts.push_back(start);
            pts.push_back(end);
            for (int d = -1; d <= 1; d++) pts.push_back((start + end) / 2 + d);

            events.push_back(event(start, tg, -tg * 1LL * start));
            events.push_back(event((start + end + 1) / 2, -2LL * tg, 1LL * tg * (start + end)));
            events.push_back(event(end, tg, -tg * 1LL * end));
        }
    }

    sort(pts.begin(), pts.end());
    pts.resize(unique(pts.begin(), pts.end()) - pts.begin());
    sort(events.begin(), events.end());

    ll cmx = -1;
    cur = 0;
    ll curA = 0, curB = 0;
    for (int i = 0; i < (int)pts.size(); i++) {
        int x = pts[i];
        while (cur < (int)events.size() && events[cur].x <= x) {
            curA += events[cur].a;
            curB += events[cur].b;
            cur++;
        }
        cmx = max(cmx, curA * x + curB);
    }
    cout << ans - cmx << endl;
 
    return 0;
}