import ru.ifmo.testlib.Checker;
import ru.ifmo.testlib.InStream;
import ru.ifmo.testlib.Outcome;
import ru.ifmo.testlib.Outcome.Type;
import java.util.BitSet;

public class Check implements Checker {

    @Override
    public Outcome test(InStream inf, InStream ouf, InStream ans) {
        int n = inf.nextInt();
        int m = inf.nextInt();
		for (int i = 0; i < m; i++) {
		  String juryAns = ans.nextToken();
		  String partAns = ouf.nextToken();
		  if (!juryAns.equals(partAns)) {
		    return new Outcome(Type.WA, "Answer for " + (i + 1) + " query is different. Expected " + juryAns + ", found " + partAns);
		  }
		}
		return new Outcome(Type.OK, "OK");
    }
}
