#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1 << 20;

int n, m, len;
int a[MAXN];
pair<int, int> b[MAXN];
int mn[MAXN];

int main() {
    memset(mn, 127, sizeof(mn));

    scanf("%d%d%d", &n, &m, &len);
    for (int i = 0; i < n; i++) scanf("%d", &a[i]);
    for (int i = 0; i < m; i++) scanf("%d", &b[i].first), b[i].second = i;
    sort(b, b + m);

    int ITERS = min(1 * 1000 * 1000, len + 1 - n);
    priority_queue<pair<int, pair<int, int> > > q;
    for (int i = 0; i + 1 < n; i++) q.push(make_pair(a[i + 1] - a[i], make_pair(i, 1)));

    int cur = 0;
    while (cur < m && b[cur].first == 0) {
        mn[cur++] = q.top().first;
    }

    for (int it = 1; it <= ITERS; it++) {
        int v = q.top().second.first;
        int cnt = q.top().second.second;
        q.pop();
        int len = a[v + 1] - a[v];
        cnt++;
        int mx = (len + cnt - 1) / (cnt);
        q.push(make_pair(mx, make_pair(v, cnt)));

        while (cur < m && b[cur].first == it) {
            mn[cur++] = q.top().first;
        }
    }
    if (cur < m) mn[cur] = q.top().first;

    vector<int> difs;
    for (int i = 0; i + 1 < n; i++) {
        difs.push_back(a[i + 1] - a[i]);
    }
    sort(difs.begin(), difs.end());
    difs.resize(unique(difs.begin(), difs.end()) - difs.begin());
    vector<pair<int, int> > vct(difs.size());
    for (int i = 0; i < (int)difs.size(); i++) vct[i].first = difs[i];
    for (int i = 0; i + 1 < n; i++) {
        vct[lower_bound(difs.begin(), difs.end(), a[i + 1] - a[i]) - difs.begin()].second++;
    }

    cerr << clock() / (double)CLOCKS_PER_SEC << endl;
    // now ans * 2 <= 500
    int mmx = q.top().first;
    for (int ans2 = 1; ans2 <= mmx - 1; ans2++) {
        int need = 0;
        for (int i = 0; i < (int)vct.size(); i++) {
            // vct[i].first / x <= ans2
            // x >= vct[i].first / ans2
            int x = (vct[i].first + ans2 - 1) / ans2 - 1;
            need += x * vct[i].second;
        }
        int id = lower_bound(b, b + m, make_pair(need, -1)) - b;
        mn[id] = min(mn[id], ans2);
    }
    for (int i = 1; i < m; i++) mn[i] = min(mn[i], mn[i - 1]);

    vector<int> ans(m);
    for (int i = 0; i < m; i++) ans[b[i].second] = mn[i];
    for (int i = 0; i < m; i++) printf("%d\n", ans[i]);
    
    cerr << clock() / (double)CLOCKS_PER_SEC << endl;

    return 0;
}