import ru.ifmo.testlib.Checker;
import ru.ifmo.testlib.InStream;
import ru.ifmo.testlib.Outcome;
import ru.ifmo.testlib.Outcome.Type;

public class Check implements Checker {

    @Override
    public Outcome test(InStream inf, InStream ouf, InStream ans) {
        int n = inf.nextInt();
        
        for (int i = 0; i < n; i++) {
        	int part = ouf.nextInt(), jury = ans.nextInt();
        	if (part != jury) {
        		return new Outcome(Type.WA, "Line " + (i + 1) + " is not correct: expected: " + jury + ", but found: " + part);
        	}
        }
        
        return new Outcome(Type.OK, "OK");
    }
}
